--[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]][][][][][][][][][]
-- Name = SunMoon.lua
-- Version = 17032013
-- Information = Script to position images based position of the sun and moon.
-- License = Creative Commons BY-NC-SA 3.0
--[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]][][][][][][][][][]

function Initialize()
		OldTimes = nil
		OldEffect = nil
		iTwilight = 0
end -- function Initialize

function Update()

-- check to see if the day has changed
	local TodayTimes = tonumber(SKIN:GetVariable('todaysday'))
		if OldTimes ~= TodayTimes then
			 SKIN:Bang("!UpdateMeasure mLuaSunMoonTimes") 
			OldTimes = TodayTimes
		end

-- get sunrise, sunset, moonrise, moonset and twightlight times (set by SunMoonTimes.lua)
		iSunRise = tonumber(SKIN:GetVariable('iSunrise'))	
		iSunSet = tonumber(SKIN:GetVariable('iSunset'))	
		iMoonRise = tonumber(SKIN:GetVariable('iMoonrise'))	
		iMoonSet = tonumber(SKIN:GetVariable('iMoonset'))	
		iTwiMorning = tonumber(SKIN:GetVariable('iTwiMorning'))		
		iTwiEvening = tonumber(SKIN:GetVariable('iTwiEvening'))
		
-- get the time now	
	iTimeNow = (tonumber(os.date('%H')) * 3600) + (tonumber(os.date('%M')) * 60) + tonumber(os.date('%S')-30)

-----  [ ---------  set the time for testing ------------- ] ------
   -- sHours = 14
	-- sMinutes = 55
	-- iTimeNow = (tonumber(sHours) * 3600) + (tonumber(sMinutes) * 60) - 30
-- OR relative time
	-- iTimeNow=iTimeNow - (  (tonumber(sHours) * 3600) + (tonumber(sMinutes) * 60)  )
-----------------------------------------------------------------------	

 -- display sun or sun balance 
	displayImage('MtSun' ,iSunRise, iSunSet )	
 -- display moon or moon balance
	displayImage('MtMoon' ,iMoonRise, iMoonSet )
	
-- check for twilight effects
	if iTwiMorning>0 and iTwiEvening>0 then
		if iTimeNow >=iTwiMorning and iTimeNow < iSunRise then iTwilight=1
			elseif	iTimeNow <=iTwiEvening and iTimeNow >=  iSunSet then	iTwilight=2
				else iTwilight=0
		end	
	end
	if OldEffect ~= iTwilight then 
		twilightEffects(iTwilight)	
		OldEffect = iTwilight
	end

	return "[ Images Updated at "..TimeString(iTimeNow).." ] "
	
end -- function Update  ----------------------------------------------------

function displayImage( sMeterName , a, b )
	local iObjYpos = imagePosition( a, b, a , b ) 
	if sMeterName=='MtMoon' and iObjYpos>76 and iObjYpos<718 then 
		SKIN:Bang('!SetOption', 'MtMoonShade', 'Y', (iObjYpos+43) ) 
		SKIN:Bang('!SetOption', 'MtMoonShine', 'Y', (iObjYpos+43) ) 
		SKIN:Bang('!ShowMeterGroup','MoonShade' ) 	
	else 
		SKIN:Bang('!HideMeterGroup','MoonShade' ) 
	end	
	if (iObjYpos>76) and (iObjYpos<765) then
		iObjYpos=cropImage( iObjYpos, ''..sMeterName..'' ) 
		SKIN:Bang('!SetOption',''..sMeterName..'', 'Y', iObjYpos)
		SKIN:Bang('!SetOption',''..sMeterName..'', 'ImageName', ''..sMeterName..sObjDir..'')		
		SKIN:Bang('!ShowMeter', ''..sMeterName..'')
		SKIN:Bang('!HideMeter', ''..sMeterName..'Balance')
	else	
		SKIN:Bang('!HideMeter',''..sMeterName..'')			
		 displayBackingImage(''..sMeterName..'Balance',b,a,a,b)
	end
end -- function displayImage

function displayBackingImage( sMeterName , a, b, c, d )
	local iObjYpos = imagePosition( a, b, c, d ) 
	if (iObjYpos>76) and (iObjYpos<765) then  -- showing backing image
		iObjYpos=cropImage( iObjYpos, ''..sMeterName..'' )		
		SKIN:Bang('!SetOption',''..sMeterName..'', 'Y', iObjYpos)
		SKIN:Bang('!SetOption',''..sMeterName..'', 'ImageName', ''..sMeterName..sObjDir..'')			
		SKIN:Bang('!ShowMeter', ''..sMeterName..'')
	else
		 SKIN:Bang('!HideMeter',''..sMeterName..'')
	end	
end -- function displayBackingImage	

function imagePosition(iRise, iSet, iObjRise, iObjSet)
	if iRise==iObjRise then -- showing sun/moon	
		if iSet>iRise then iHigh = iObjRise+((iObjSet-iObjRise)/2) 
			else
				iHigh = ((86400-iRise+iSet)/2)+iRise
		end
		rStep = ( 640 / (iHigh-iRise) )
		iAppear = Round( iRise - ( 47 / rStep))
		iLeave = Round( iSet + ( 47 / rStep))
	else	-- showing balances
	if iObjSet>iObjRise then iHigh =(((86400-iObjSet+iObjRise)/2)+iObjSet)
			else
				iHigh = iObjRise+((iObjSet-iObjRise)/2) 
		end	
		rStep = ( 640 / (iHigh-iRise) )
		local iOverlap=( 12 / ( 640 / ((iObjRise+((iObjSet-iObjRise)/2)-iObjRise) )))
		iAppear = Round( iObjSet + iOverlap)
		iLeave = Round( iObjRise - iOverlap )
	end
	if iTimeNow >= iAppear and iTimeNow <= iHigh then  -- Ypos going up
		sObjDir=1
		return (77 + Round( (iHigh-iTimeNow )* rStep))	
	elseif (iTimeNow > iHigh and iTimeNow <= iLeave) or ( iTimeNow > (iHigh-86400) and iTimeNow <= iLeave) then-- Ypos coming down
		sObjDir=0
		return (716 - Round( (iSet-iTimeNow )* rStep)) 
	 elseif 	( iHigh> iLeave and iTimeNow <= iHigh ) then  -- Ypos going up after midnight
		sObjDir=1
		return (77 + Round( (iHigh-86400-iTimeNow )* rStep))	
	elseif (iTimeNow > iHigh and iHigh <= 86400) then	-- Ypos going up before midnight
		sObjDir=0
		return (77 + Round( (iTimeNow-iHigh) )* rStep)
	else
		return 0
	end
end --function imagePosition

function cropImage( Ypos, sMeterName )
	if Ypos <116 then
		SKIN:Bang('!SetOption',''..sMeterName..'','ImageCrop', '0,'..(115-Ypos)..',77,152')
		return 116
	end	
	if Ypos>603 then
		SKIN:Bang('!SetOption',''..sMeterName..'','ImageCrop', '0,0,77,'..(765-Ypos)..'"')		
		if sMeterName=='MtMoon' then 
		SKIN:Bang('!SetOption','MtMoonShade','ImageCrop', '0,0,57,'..(722-Ypos)..'"')
		SKIN:Bang('!SetOption','MtMoonShine','ImageCrop', '0,0,57,'..(722-Ypos)..'"')
		end
	end
	return Ypos
end	-- function cropImage

function Round(num)
	return math.floor(num + 0.5)
end -- function round

function  twoDigitsFormat(num)  --	add a leading 0 
	if (num<10)  then return "0"..tostring(num) 
		else return tostring(num) 
	end
end -- function twoDigitsFormat

function TimeString(num)
	local hours=math.floor( (num/3600) )
	local minutes=Round((num-(hours*3600))/60)
	if hours>11 and hours<24 then AmPm=' pm' else AmPm=' am' end
	if hours>0 then	hours=((hours+ 12 -1)% 12+ 1) end	
	return hours..":"..twoDigitsFormat(minutes)..AmPm
end -- function TimeString

function twilightEffects( effect )
		if tonumber(effect)==1 then
			SKIN:Bang('!SetOption', 'MtTimePlate', 'ImageName', 'm2.png')
			SKIN:Bang('!HideMeter', 'MtTimeNow')   
			SKIN:Bang('!SetVariable ClockOn 0')
			SKIN:Bang('!SetOption', 'MtBottomFan', 'ImageName', '#@#Images\\Dawn.png')
			SKIN:Bang('!SetOption', 'MtBacker', 'SolidColor', '1a0602')
		end	
		if tonumber(effect)==2 then
			SKIN:Bang('!SetOption', 'MtTimePlate', 'ImageName', 'm2.png')
			SKIN:Bang('!HideMeter', 'MtTimeNow')   
			SKIN:Bang('!SetVariable ClockOn 0')
			SKIN:Bang('!SetOption', 'MtBottomFan', 'ImageName', '#@#Images\\Dusk.png')
			SKIN:Bang('!SetOption', 'MtBacker', 'SolidColor', '04062f')
		end
		if tonumber(effect)==0 then
			local clockOn = math.abs( tonumber(SKIN:GetVariable('ClockOn'))-1)
			SKIN:Bang('!SetOption', 'MtTimePlate', 'ImageName', ('m'..clockOn..'.png') )
			SKIN:Bang('!SetOption', 'MtBottomFan', 'ImageName', '#@#Images\\f0.png')
			SKIN:Bang('!SetOption', 'MtBacker', 'SolidColor', '000000')
		end	
		SKIN:Bang('!UpdateMeter', 'MtBacker')
		SKIN:Bang('!UpdateMeter', 'MtTimePlate')
end -- function twilight effects