--[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]][][][][][][][][][][][][][][][][][][][]
-- Author = Mordasius
-- Name = SunMoonTimes.lua
-- Version =300313
-- Information = Script to calculate sun and moon rise and set times based  on date, latitude and longitude.
-- License=Creative Commons BY-NC-SA 3.0

 --  Functions for sunrise, sunset and twilight were converted from javascript on http://praytimes.org/
--  The parts for moonrise and moonset were converted by Stone from C which came from javascript on http://mysite.verizon.net/res148h4j/javascript/script_moon_rise_set.html ( see Stone's post on  http://rainmeter.net/forum/viewtopic.php?f=27&t=15071 )
--[][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][][]][][][][][][][][][][][][][][][][][][][]

function Initialize()	
	    nLatitude = tonumber(SKIN:GetVariable('Latitude'))
		nLongitude = tonumber(SKIN:GetVariable('Longitude'))
		nTimeZone = tonumber(SKIN:GetVariable('tZone'))
		dawnAngle, duskAngle = 6, 6	
		M_PI = math.pi
		DR = M_PI / 180
		K1 = 15 * M_PI * 1.0027379 / 180
end -- function Initialize
-----------------------------------------------------------------------------------------
function Update()     

-- reset default values
	sunRiseSetTimes= {6, 6,6,12,13,18,18,18,24}  
	moonRiseSetTimes= {0,23.9} 
	NoSunRise, NoSunSet = False, False
	strSunTip, strSunsetTip, 	strTwilightTip= '','',''
	Sky = {0,0,0}	Dec = {0,0,0}	VHz = {0,0,0}	RAn = {0,0,0}
	StrMoonRiseTip="Moonrise: Last night" 
	StrMoonSetTip= 'Moonset: Tomorrow' 
	
-- set time and gregorian date	
		setDateTime( nLatitude, nLongitude, nTimeZone ) 	
		
-- sun time calculations		
	    calcSunRiseSet()		
		if NoSunRise or NoSunSet then	-- adjust times to solar noon
				sunRiseSetTimes[2] =(sunRiseSetTimes[2]-12)
				if NoSunRise then
					sunRiseSetTimes[3] = sunRiseSetTimes[2]+0.0001
					else
					sunRiseSetTimes[3] =(sunRiseSetTimes[2]-0.0001)
				end	
				sunRiseSetTimes[1] = 0  sunRiseSetTimes[4] = 0
				strTwilightTip="No twilight today"
		else 
			strSunTip="Sunrise: "..TimeString(sunRiseSetTimes[2]).."#CRLF#Sunset: "..TimeString(sunRiseSetTimes[3])
			strTwilightTip="Morning twilight: "..TimeString(sunRiseSetTimes[1]).." to "..TimeString(sunRiseSetTimes[2]).."#CRLF#Evening twilight: "..TimeString(sunRiseSetTimes[3]).." to "..TimeString(sunRiseSetTimes[4])	
		end  
		
		SKIN:Bang('!SetVariable iTwiMorning  "'..(sunRiseSetTimes[1]*3600)..'"')
		SKIN:Bang('!SetVariable iSunRise  "'..(sunRiseSetTimes[2]*3600)..'"')
		SKIN:Bang('!SetVariable iSunSet  "'..(sunRiseSetTimes[3]*3600)..'"')
		SKIN:Bang('!SetVariable iTwiEvening  "'..(sunRiseSetTimes[4]*3600)..'"')	

 -- set sun tooltips
		SKIN:Bang('!SetOption', 'MtSun' , 'ToolTipText', ''..strSunTip..'')
		SKIN:Bang('!SetOption', 'MtSunBalance' , 'ToolTipText', ''..strSunTip..'')
		SKIN:Bang('!SetOption', 'MtTopSpinner', 'ToolTipText', ''..strTwilightTip..'' )
		
-- moon time calculations	
		calcMoonRiseSet( nLatitude, nLongitude, jDateMoon, moonTimeOffset)
		SKIN:Bang('!SetVariable iMoonRise "'..(moonRiseSetTimes[1]*3600)..'"')
		SKIN:Bang('!SetVariable iMoonSet "'..(moonRiseSetTimes[2]*3600)..'"')
		
		if moonRiseSetTimes[2] > moonRiseSetTimes[1] then
				SKIN:Bang('!SetVariable sMoonTip  "'..StrMoonRiseTip..'#CRLF#'..StrMoonSetTip..'"')
				sMoonTip  = ''..StrMoonRiseTip..'#CRLF#'..StrMoonSetTip
			else
				SKIN:Bang('!SetVariable sMoonTip  "'..StrMoonSetTip..'#CRLF#'..StrMoonRiseTip..'"')
				sMoonTip =  ''..StrMoonSetTip..'#CRLF#'..StrMoonRiseTip
		end		
		if moonRiseSetTimes[1]  == 0 and iTimeNow > moonRiseSetTimes[2] then
			sMoonTip  = ''..StrMoonSetTip..'#CRLF#Moonrise: Tomorrow'
		end

-- set moon tooltips
		SKIN:Bang('!SetOption', 'MtMoon',  'ToolTipText', 'Phase: [mTextPhase]#CRLF#[mIllum]% illuminated#CRLF#'..sMoonTip..'#CRLF#Next phase: [mNextPhase]#CRLF#in [mDaysTo] days on [mNextDay] [mNextMonth]')
		SKIN:Bang('!SetOption', 'MtMoonBalance',  'ToolTipText', 'Moon Phase: [mTextPhase]#CRLF#Not visible at this time.#CRLF#'..sMoonTip..'#CRLF#Next phase: [mNextPhase]#CRLF#in [mDaysTo] days on [mNextDay] [mNextMonth]')
	
	return	"[ rise and set times for "..Gday..'/'..Gmonth.." set at "..TimeString(iTimeNow).." ]" 

end -- function Update		
-----------------------------------------------------------------------

function setDateTime( xlat, ylong, tmzone )  
		lat = xlat or 0
		long = ylong or 0
		timeOffset = tmzone
		iTimeNow =((tonumber(os.date('%H')) * 3600) + (tonumber(os.date('%M')) * 60) + tonumber(os.date('%S')))/3600	
		local today = os.date('*t')
		Gday = today.day	Gmonth = today.month	  Gyear = today.year		
----------- for testing ------			
		-- Gday =12  Gmonth =4 Gyear = 2013	
-----------------------------------------------------------------------	
		SKIN:Bang('!SetVariable TodaysDay  "'..Gday..Gmonth..'"')
		moonTimeOffset = (-60) * timeOffset			
		jDateSun =julian( Gyear, Gmonth, Gday ) - (long/ (15* 24))        
		jDateMoon =  julian(Gyear, Gmonth, Gday) 

end  -- of function setDateTime

-----------  [   sun time calaculations   ]  ---
function  midDay(Ftime) 
		local eqt = sunPosition( jDateSun+ Ftime, 0 )
		local noon = DMath.fixHour(12- eqt)
		return noon
end  

function  sunAngleTime(angle, Ftime, direction) --time at which sun reaches a specific angle below horizon
		local decl = sunPosition(jDateSun+ Ftime, 1)	
		local noon = midDay(Ftime)				
		local t = (-DMath.Msin(angle)- DMath.Msin(decl)* DMath.Msin(lat))/(DMath.Mcos(decl)* DMath.Mcos(lat))		
		if  t  >1 then    -- The sun doesn't rise today
						NoSunRise=1
						strSunTip='The sun doesn\'t rise today'
						strSunsetTip='The sun doesn\'t rise today'
						return noon
			elseif t < -1 then  -- The sun doesn't set today
						NoSunSet=1
						strSunTip='The sun doesn\'t set today'
						return noon
		end
		 t = 1/15* DMath.arccos( t )
		return noon +( (direction == "CCW") and -t or t)				
end 

function  asrTime(factor, Ftime) -- compute asr time
		local decl = sunPosition(jDateSun+ Ftime, 1)
		local angle = -DMath.arccot(factor+ DMath.Mtan(math.abs(lat- decl)))		
		return sunAngleTime(angle, Ftime, "ASR")
end  

function sunPosition(jd, Declination) -- compute declination angle of sun 
		local D = jd - 2451545
		local g = DMath.fixAngle(357.529 + 0.98560028* D)
		local q = DMath.fixAngle(280.459 + 0.98564736* D)
		local L = DMath.fixAngle(q + 1.915* DMath.Msin(g) + 0.020* DMath.Msin(2*g))
		local R = 1.00014 - 0.01671* DMath.Mcos(g) - 0.00014* DMath.Mcos(2*g)
		local e = 23.439 - 0.00000036* D
		local RA = DMath.arctan2(DMath.Mcos(e)* DMath.Msin(L), DMath.Mcos(L))/ 15
		local eqt = q/15 - DMath.fixHour(RA)
		local decl = DMath.arcsin(DMath.Msin(e)* DMath.Msin(L))	
		 if  Declination==1  then return decl else return eqt end
end

function  julian(year, month, day) --  convert Gregorian date to Julian day
		if (month<=2) then	year = year-1  month = month+12	end
		local A = math.floor(year/ 100)
		local B = 2- A+ math.floor(A/ 4)
		JD = math.floor(365.25* (year+ 4716))+ math.floor(30.6001* (month+ 1))+ day+ B-1524.5
		return JD
end 
	
function  setTimes(sunRiseSetTimes) 
		Ftimes = dayPortion(sunRiseSetTimes)
		 local dawn    = sunAngleTime(dawnAngle, Ftimes[2], "CCW")	
		 local sunrise = sunAngleTime(riseSetAngle(), Ftimes[3], "CCW")
		 local sunset  = sunAngleTime(riseSetAngle(), Ftimes[8],"CW")
		 local dusk    = sunAngleTime(duskAngle, Ftimes[7],"CW") 	 	
		return {dawn, sunrise, sunset,  dusk}			
end -- of function setTimes

function  calcSunRiseSet()
		sunRiseSetTimes= setTimes(sunRiseSetTimes)		
			return adjustTimes(sunRiseSetTimes)	
end -- of function calcSunRiseSet

function adjustTimes(sunRiseSetTimes)     			 
		for i = 1, #sunRiseSetTimes do sunRiseSetTimes[i] = sunRiseSetTimes[i] + (timeOffset - long/ 15) end
		sunRiseSetTimes = adjustHighLats(sunRiseSetTimes)
		return sunRiseSetTimes
end

function riseSetAngle()  --  sun angle for sunset/sunrise
		 -- local angle = 0.0347* math.sqrt( elv ) 
		local angle = 0.0347
		return 0.833+ angle
end

function adjustHighLats(sunRiseSetTimes)  --  adjust times for higher latitudes
		local nightTime = timeDiff(sunRiseSetTimes[3], sunRiseSetTimes[2])
		sunRiseSetTimes[1] = refineHLtimes(sunRiseSetTimes[1], sunRiseSetTimes[2], (dawnAngle), nightTime, "CCW")	
		return sunRiseSetTimes
end

function refineHLtimes(Ftime, base, angle, night, direction)  --  refine time for higher latitudes
		portion = night/2
		FtimeDiff = (direction == "CCW") and  timeDiff(Ftime, base) or timeDiff(base, Ftime)
		if not  ((Ftime*2) > 2 )  or  (FtimeDiff > portion) 
			then
				Ftime = base+ ((direction == "CCW") and -portion or portion)
			end
		return Ftime
end 

function	dayPortion(sunRiseSetTimes) --  convert hours to day portions	
				for i = 1, #sunRiseSetTimes do sunRiseSetTimes[i] = sunRiseSetTimes[i] / 24	end		
		return sunRiseSetTimes
end 
	
function timeDiff(time1, time2) --	difference between two times
		return DMath.fixHour(time2- time1)
end

-----------  [   moon time calaculations   ]  ---------------
function sgn(x)   -- returns value for sign of argument
    local rv
 	if x > 0 then
		rv = 1
    else
		if x < 0 then
			rv = -1
		else
			rv = 0
		end
	end
    return rv
end  -- function sgn(x)

-- moon's position using fundamental arguments (Van Flandern & Pulkkinen, 1979)
function moon(jd)
    local d, f, g, h, m, n, s, u, v, w
    h = 0.606434 + 0.03660110129 * jd
    m = 0.374897 + 0.03629164709 * jd
    f = 0.259091 + 0.0367481952 * jd
    d = 0.827362 + 0.03386319198 * jd
    n = 0.347343 - 0.00014709391 * jd
    g = 0.993126 + 0.0027377785 * jd

    h = h - math.floor(h)
    m = m - math.floor(m)
    f = f - math.floor(f)
    d = d - math.floor(d)
    n = n - math.floor(n)
    g = g - math.floor(g)

    h = h * 2 * M_PI
    m = m * 2 * M_PI
    f = f * 2 * M_PI
    d = d * 2 * M_PI
    n = n * 2 * M_PI
    g = g * 2 * M_PI

    v = 0.39558 * math.sin(f + n)
    v = v + 0.082 * math.sin(f)
    v = v + 0.03257 * math.sin(m - f - n)
    v = v + 0.01092 * math.sin(m + f + n)
    v = v + 0.00666 * math.sin(m - f)
    v = v - 0.00644 * math.sin(m + f - 2 * d + n)
    v = v - 0.00331 * math.sin(f - 2 * d + n)
    v = v - 0.00304 * math.sin(f - 2 * d)
    v = v - 0.0024 * math.sin(m - f - 2 * d - n)
    v = v + 0.00226 * math.sin(m + f)
    v = v - 0.00108 * math.sin(m + f - 2 * d)
    v = v - 0.00079 * math.sin(f - n)
    v = v + 0.00078 * math.sin(f + 2 * d + n)

    u = 1 - 0.10828 * math.cos(m)
    u = u - 0.0188 * math.cos(m - 2 * d)
    u = u - 0.01479 * math.cos(2 * d)
    u = u + 0.00181 * math.cos(2 * m - 2 * d)
    u = u - 0.00147 * math.cos(2 * m)
    u = u - 0.00105 * math.cos(2 * d - g)
    u = u - 0.00075 * math.cos(m - 2 * d + g)

    w = 0.10478 * math.sin(m)
    w = w - 0.04105 * math.sin(2 * f + 2 * n)
    w = w - 0.0213 * math.sin(m - 2 * d)
    w = w - 0.01779 * math.sin(2 * f + n)
    w = w + 0.01774 * math.sin(n)
    w = w + 0.00987 * math.sin(2 * d)
    w = w - 0.00338 * math.sin(m - 2 * f - 2 * n)
    w = w - 0.00309 * math.sin(g)
    w = w - 0.0019 * math.sin(2 * f)
    w = w - 0.00144 * math.sin(m + n)
    w = w - 0.00144 * math.sin(m - 2 * f - n)
    w = w - 0.00113 * math.sin(m + 2 * f + 2 * n)
    w = w - 0.00094 * math.sin(m - 2 * d + g)
    w = w - 0.00092 * math.sin(2 * m - 2 * d)

    s = w / math.sqrt(u - v * v)	-- compute moon's right ascension ...  
    Sky[1] = h + math.atan(s / math.sqrt(1 - s * s))

    s = v / math.sqrt(u)		-- declination ...
    Sky[2] = math.atan(s / math.sqrt(1 - s * s))

    Sky[3] = 60.40974 * math.sqrt(u)	-- and parallax

end -- of function moon

function test_moon(k, t0, lat, plx)   -- test an hour for an event
    ha = {0,0,0}
    local a, b, c, d, e, s, z
    local hr, _min, _time
    local az, hz, nz, dz
    if (RAn[3] < RAn[1]) then
		RAn[3] = RAn[3] + 2 * M_PI
	end
    ha[1] = t0 - RAn[1] + (k * K1)
    ha[3] = t0 - RAn[3] + (k * K1) + K1
    ha[2] = (ha[3] + ha[1]) / 2	-- hour angle at half hour
    Dec[2] = (Dec[3] + Dec[1]) / 2	-- declination at half hour
    s = math.sin(DR * lat)
    c = math.cos(DR * lat)

    -- refraction + sun semidiameter at horizon + parallax correction
    z = math.cos(DR * (90.567 - 41.685 / plx))

    if (k <= 0) then			-- first call of function
		VHz[1] = s * math.sin(Dec[1]) + c * math.cos(Dec[1]) * math.cos(ha[1]) - z
	end
    VHz[3] = s * math.sin(Dec[3]) + c * math.cos(Dec[3]) * math.cos(ha[3]) - z
    if (sgn(VHz[1]) == sgn(VHz[3])) then
		return VHz[3]		-- no event this hour
	end
    VHz[2] = s * math.sin(Dec[2]) + c * math.cos(Dec[2]) * math.cos(ha[2]) - z
    a = 2 * VHz[3] - 4 * VHz[2] + 2 * VHz[1]
    b = 4 * VHz[2] - 3 * VHz[1] - VHz[3]
    d = b * b - 4 * a * VHz[1]
	
    if (d < 0) then
		return VHz[3]		-- no event this hour
	end
    
	d = math.sqrt(d)
    e = (-b + d) / (2 * a)
    if ((e > 1) or (e < 0)) then
		e = (-b - d) / (2 * a)
	end	
    _time = k + e + 1 / 120	-- time of an event + round up

    if ((VHz[1] < 0) and (VHz[3] > 0)) then
	    moonRiseSetTimes[1] = _time
		StrMoonRiseTip= 'Moonrise: '..TimeString(moonRiseSetTimes[1])
    end
	
    if ((VHz[1] > 0) and (VHz[3] < 0)) then
		moonRiseSetTimes[2] = _time
		StrMoonSetTip= 'Moonset: '..TimeString(moonRiseSetTimes[2])
    end
	
    return VHz[3]
end -- of function testmoon

-- Local Sidereal Time for zone
function lst(lon, jd, z)
    s = 24110.5 + 8640184.812999999 * jd / 36525 + 86636.6 * z + 86400 * lon
    s = s / 86400
    s = s - math.floor(s)
    return s * 360 * DR
end -- of function lst

function interpolate(f0, f1, f2, p)  -- 3-point interpolation
	a = f1 - f0
	b = f2 - f1 - a
	f = f0 + p * (2 * a + b * (2 * p - 1))
    return f
end -- of function  interpolate

function calcMoonRiseSet( lat,  lon, jDateMoon,  moonTimeOffset) -- calculate moonrise and moonset times
    local i, j, k
    local zone = moonTimeOffset / 60
    local ph
	jd=jDateMoon- 2451545	-- Julian day relative to Jan 1.5, 2000
    local mp={}
    lon_local = lon
	for i = 1,3 do
		mp[i]={}
		for j = 1,3 do
			mp[i][j] = 0
		end
	end
    lon_local = lon / 360
    tz = zone / 24
    t0 = lst(lon_local, jd, tz)	-- local sidereal time
    jd = jd + tz		-- get moon position at start of day
    for k = 1,3 do
		moon(jd)
		mp[k][1] = Sky[1]
		mp[k][2] = Sky[2]
		mp[k][3] = Sky[3]
		jd = jd + 0.5
    end

    if (mp[2][1] <= mp[1][1]) then
		mp[2][1] = mp[2][1] + 2 * M_PI
	end
    if (mp[3][1] <= mp[2][1]) then
		mp[3][1] = mp[3][1] + 2 * M_PI
	end
    RAn[1] = mp[1][1]
    Dec[1] = mp[1][2]
	
    for k = 0,23 do	-- check each hour of this day
		ph = (k + 1) / 24
		RAn[3] = interpolate(mp[1][1], mp[2][1], mp[3][1], ph)
		Dec[3] = interpolate(mp[1][2], mp[2][2], mp[3][2], ph)
		VHz[3] = test_moon(k, t0, lat, mp[2][3])
		RAn[1] = RAn[3]	-- advance to next hour
		Dec[1] = Dec[3]
		VHz[1] = VHz[3]
    end	
end  -- end of function calcMoonRiseSet
------------------------------------------------------------------------

------  [   other odds and sods  ]  --------------

function getTimeOffset()
   return (os.time() - os.time(os.date('!*t')) + (os.date('*t')['isdst'] and 3600 or 0)) 
end

function  twoDigitsFormat(num)  --	add a leading 0 
	if (num<10)  then return "0"..tostring(num) 
		else return tostring(num) 
	end
end -- function twoDigitsFormat

function  TimeString( Ftime )  -- put string in Hrs : mins format - 12h version
		local hours = math.floor(Ftime)
		local minutes = math.floor( (Ftime- hours)* 60)
		if hours>11 and hours<24 then AmPm=' pm' else AmPm=' am' end
		if hours>0 then	hours=((hours+ 12 -1)% 12+ 1) end	
		return hours..":"..twoDigitsFormat(minutes)..AmPm
end -- function TimeString

-------------[  math functions  ] ---------------------
function fix(a, b) 
		a = a- b* (math.floor(a/ b))
		return (a < 0) and a+ b or a
end

function dtr(d)  return (d * math.pi) / 180 end
function rtd(r) return (r * 180) / math.pi end

DMath = {	
		Msin = function(d) return math.sin(dtr(d)) end,
		Mcos = function(d) return math.cos(dtr(d)) end,
		Mtan = function(d)  return math.tan(dtr(d)) end,
		arcsin =  function(d)  return rtd(math.asin(d)) end,
		arccos =  function(d)  return rtd(math.acos(d)) end,
		arctan =  function(d)  return rtd(math.atan(d)) end,
		arccot =  function(x)  return rtd(math.atan(1/x)) end,
		arctan2 =  function(y, x)  return rtd(math.atan2(y, x)) end,
		fixAngle =  function(a)  return fix(a, 360) end,
		fixHour =   function(a)  return fix(a, 24 ) end       
	}